;;; blue.scm
;;; All common 'blue' data and definitions can go in here

; global variables
(define *game-name* 'blue)       ; Name of the game (for network handshaking)
(define *version* 1.0)           ; Game version (for handshaking)
(define *pan-thresh* 250)        ; Panning threshold
(define *width* 800)             ; Width of the game window
(define *height* 600)            ; Height of the game window
(define *actual-field-width* 1600) ; Actual game field width
(define *actual-field-height* 1200) ; Acutual game field height
(define *field-width* (- *actual-field-width* *pan-thresh*))      ; width of the field (-200) used for spawning tanks (I think...)
(define *field-height* (- *actual-field-height* *pan-thresh*))     ; height of the field (-200) " "
(define *pi* 3.14159)            ; Pi
(define *refresh-delay* 0.020)   ; Drawing refresh delay
(define *bullet-life* 0.8)       ; Time for a bullet to live/exist (in seconds)
(define *respawn-time* 2)        ; Time to wait before giving a new life to a destroyed tank

; grow a vector and return a newly sized vector that contains
; the contents of the old vector plus a bunch of empty space
(define vec-grow
  (lambda (vec k)
    (let loop ((i 0)
               (oldvec vec)
               (newvec (make-vector k '())))
      (if (>= i (vector-length oldvec))
          newvec
          (begin
            (vector-set! newvec i (vector-ref oldvec i))
            (loop (+ i 1) oldvec newvec))))))

; generic 'blue' object
(define-struct object
 (type 
  x 
  y 
  theta 
  movement 
  rotate 
  color 
  owner
  time-stamp
  thread-desc))

