;;; 'blue' server handshaking functions
;;; Justin R. Hall (c) 2003

;;; handshaking - the special case

(define handshake
  (lambda (in out)
    ; start handshake; hopefully we receive (ok ...) function call
    (if *debug*
        (begin
          (display "Handshaking...")
          (newline)))
    
    (hello *game-name* *version* in out)
    
    (let ((input (read in)))
      (if (eqv? (car input) 'ok)
          (begin
            (eval (append input `(,in) `(,out)))
            #t) #f))))

; server salutes client
(define hello
  (lambda (game-name version in out)
    (display `(hello ',game-name ,version) out)))

; client responds to server, now server
; sends some init commands to client
(define ok
  (lambda (game-name version in out)
    (if (and (equal? game-name *game-name*)
             (equal? version *version*))
        (begin
          (if *debug*
              (begin
                (display "Handshake complete.") 
                (newline)))
          
          ; tell the client about the other objects
          (call (send-game-state *game-state* out))
          
          ; create a tank object for the client
          (let* ((next-index (call (next-available-index *game-state*)))
                 (object-params
                 `(,next-index 'tank ,(+ (random *field-width*) 100) ,(+ (random *field-height*) 100)
                   0 'stop 'stop ',(get-random-color) ,next-index)))
            
            ; put the new tank in the master game-state
            (if *debug*
                (begin
                  (display "Adding object to master *game-state*...")
                  (newline)))
            (call (add-object (append object-params `(,in ,out))))
          
            (if *debug*
                (begin
                  (display "*game-state*: ")
                  (display *game-state*)
                  (newline)))
            
            ; tell everyone about the new tank
            (call (tell-all-except (cons 'add-object object-params) #f))
          
            ; tell the client which tank he is
            (display `(you-are ,next-index) out)))
        (close-connection in out))))
