;;; 'blue' server utility functions
;;; Justin R. Hall (c) 2003

; wrapper for all server functions to ensure thread syncing
(define call
  (lambda (func)
    (let ((retval '()))
      (semaphore-wait *server-semaphore*)
      (set! retval (eval func))
      (semaphore-post *server-semaphore*)
      retval)))

; determines whether a command is valid
(define valid-command?
  (lambda (cmd)
    #t))
;    (cond 
;      ((not (no-inside-lists cmd)) #f)
;      ((eqv? (car cmd) 'ok) #t)
;      ((eqv? (car cmd) 'add-object) #t)
;      ((eqv? (car cmd) 'update-object) #t)
;      ((eqv? (car cmd) 'fire) #t)
;      ((eqv? (car cmd) 'collision) #t)
;      ((eqv? (car cmd) 'chat) #t)
;      (else #t))))

; determines whether a list contains sub-lists
; NOTE: DOES NOT WORK?!
(define no-inside-lists
  (lambda (cmd)
    (cond
      ((null? cmd) #t)
      ((list? (car cmd)) #f)
      (else (no-inside-lists (cdr cmd))))))

; returns the index (or #f if not there) of
; item in vec using pred? as the comparison
; predicate
(define vector-find
  (lambda (vec item pred?)
    (let ((len (vector-length vec)))
      (let loop ((position 0))
        (cond ((= position len) #f)
              ((pred? item (vector-ref vec position)) position)
              (else (loop (+ position 1))))))))

; finds and returns the number of non-null
; elements in the given vector
(define vector-num-elements
  (lambda (vec)
    (let ((len (vector-length vec)))
      (let loop ((pos 0) (count 0))
        (cond ((= pos len) count)
              ((not (null? (vector-ref vec pos)))
               (loop (+ pos 1) (+ count 1)))
              (else (loop (+ pos 1) count)))))))
  
; get a random tank color
(define get-random-color
  (lambda ()
    (let ((n (random 10)))
      (case n
        ((0) "Black")
        ((1) "Blue")
        ((2) "Red")
        ((3) "Green")
        ((4) "Orange")
	((6) "Gray")
        ((5) "Cyan")
        ((7) "Maroon")
        ((8) "Violet")
        ((9) "Brown")))))

